#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DarkGray
#property indicator_color3  Orange
#property indicator_color4  DeepSkyBlue
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width4  2

extern int    StochPeriod         = 14;
extern int    StochSlowing        =  3;
extern int    StochPrice          =  0;
extern int    BollingerPeriod     = 20;
extern double BollingerDeviations =  1;

double bollup[];
double bollmi[];
double bolldn[];
double stoch[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bollup);
   SetIndexBuffer(1,bollmi);
   SetIndexBuffer(2,bolldn);
   SetIndexBuffer(3,stoch);
   return(0); 
}

int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) stoch[i] = iStochastic(NULL,0,StochPeriod,1,StochSlowing,MODE_SMA,StochPrice,MODE_MAIN,i);
   for(    i=limit; i>=0; i--)
   {
       double dev = iStdDevOnArray(stoch,0,BollingerPeriod,0,MODE_SMA,i);
             bollmi[i] = iMAOnArray(stoch,0,BollingerPeriod,0,MODE_SMA,i);
             bollup[i] = bollmi[i]+BollingerDeviations*dev;
             bolldn[i] = bollmi[i]-BollingerDeviations*dev;
   }
   return(0);
}


